<?php

// $Id: flvmediaplayer_menu.inc,v 1.1.2.1.2.4 2008/12/15 05:34:43 arthuregg Exp $

/**
 * @FILE this is the menu include- makes tracking changes a bit
 *       easier as well as decreasing the amount of code parsed
 */


/**
 * Implementation of hook_menu().
 * called from flvmediaplayer_menu()
 *
 * @param boolean $may_cache
 * @return array
 */
function flvmediaplayer_menu_inc() {
   // default page
  $items['admin/settings/flvmediaplayer'] = array(
    'title' => t('FLV Media Player settings'),
    'description' => t('Settings for the FLV Media Player.'),
    'page callback' => 'drupal_get_form',
    'page arguments' => array('flvmediaplayer_admin_settings'),
    'access arguments' => array('administer flvmediaplayer'),
    'type' => MENU_LOCAL_TASK,
  );

  $items['admin/settings/flvmediaplayer/default'] = array (
    'title' => t('FLV Media Player settings'),
    'description' => t('Settings for the FLV Media Player.'),
    'page callback' => 'drupal_get_form',
    'page arguments' => array('flvmediaplayer_admin_settings'),
    'access arguments' => array('administer flvmediaplayer'),
    'type' => MENU_DEFAULT_LOCAL_TASK,
  );

  // profiles
  $items['admin/settings/flvmediaplayer/profiles'] = array (
    'title' => t('Profiles'),
    'description' => t('Profiles for FLV Media Player.'),
    'page callback' => 'flvmediaplayer_admin_profiles',
    'access arguments' => array('administer flvmediaplayer'),
    'type' => MENU_LOCAL_TASK,
    'file' => 'flvmediaplayer_profiles.inc',
  );

  // export pages
  $items['admin/settings/flvmediaplayer/export'] = array(
    'page callback' => 'drupal_get_form',
    'page arguments' => array('flvmediaplayer_export_form', 4),
    'access arguments' => array('administer flvmediaplayer'),
    'type' => MENU_LOCAL_TASK,
    'title' => t('Export'),
    'description' => t('Export flvmediaplayer profile'),
    'weight' => 9,
    'file' => 'flvmediaplayer_io.inc',
  );

  // export pages
  $items['admin/settings/flvmediaplayer/import'] = array(
    'page callback' => 'drupal_get_form',
    'page arguments' => array('flvmediaplayer_import_form', arg(4)),
    'access arguments' => array('administer flvmediaplayer'),
    'type' => MENU_LOCAL_TASK,
    'title' => t('Import'),
    'description' => t('Import flvmediaplayer profile'),
    'weight' => 9,
    'file' => 'flvmediaplayer_io.inc',
  );

  // external configuration page
  $items['node/%/flvmediaplayer'] = array (
    'page callback' => 'flvmediaplayer_config_xml_page',
    'page arguments' => array(0, 1),
    'access arguments' => array('content'),
    'type' => MENU_CALLBACK,
  );

  return $items;
}