<?php

// $Id: flvmediaplayer_profiles.inc,v 1.1.2.2.2.2 2008/12/14 22:26:59 arthuregg Exp $

/* TODO db_next_id() is gone, and replaced as db_last_insert_id()
   Since db_next_id() introduce some problems, and the use of this function
   can be replaced by database level auto increment handling, db_next_id()
   is now gone and replaced as db_last_insert_id() with help of serial type
   under Schema API (check out http://drupal.org/node/149176 for more details).
   Please refer to drupal_write_record() as demonstration. */

/* TODO FormAPI image buttons are now supported.
   FormAPI now offers the 'image_button' element type, allowing developers to
   use icons or other custom images in place of traditional HTML submit buttons.

$form['my_image_button'] = array(
  '#type'         => 'image_button',
  '#title'        => t('My button'),
  '#return_value' => 'my_data',
  '#src'          => 'my/image/path.jpg',
); */

/* TODO Remove $row argument from db_result() method
   The $row argument of db_result() was removed from the database abstraction
   layer in 6.x core, as it was a database dependent option. Developers need to
   use other handling to replace the needs of this method. */

/* TODO Change 'Submit' to 'Save' on buttons
   It has been agreed on that the description 'Submit' for a button is not a
   good choice since it does not indicate what actually happens. While for
   example on node editing forms, 'Preview' and 'Delete' describe exactly what
   will happen when the user clicks on the button, 'Submit' only gives a vague
   idea. When labelling your buttons, make sure that it is clear what this
   button does when the user clicks on it. */

/* TODO Node previews and adding form fields to the node form.
   There is a subtle but important difference in the way node previews (and other
   such operations) are carried out when adding or editing a node. With the new
   Forms API, the node form is handled as a multi-step form. When the node form
   is previewed, all the form values are submitted, and the form is rebuilt with
   those form values put into $form['#node']. Thus, form elements that are added
   to the node form will lose any user input unless they set their '#default_value'
   elements using this embedded node object. */

/* TODO New user_mail_tokens() method may be useful.
   user.module now provides a user_mail_tokens() function to return an array
   of the tokens available for the email notification messages it sends when
   accounts are created, activated, blocked, etc. Contributed modules that
   wish to make use of the same tokens for their own needs are encouraged
   to use this function. */

/* TODO
   There is a new hook_watchdog in core. This means that contributed modules
   can implement hook_watchdog to log Drupal events to custom destinations.
   Two core modules are included, dblog.module (formerly known as watchdog.module),
   and syslog.module. Other modules in contrib include an emaillog.module,
   included in the logging_alerts module. See syslog or emaillog for an
   example on how to implement hook_watchdog.
function example_watchdog($log = array()) {
  if ($log['severity'] == WATCHDOG_ALERT) {
    mysms_send($log['user']->uid,
      $log['type'],
      $log['message'],
      $log['variables'],
      $log['severity'],
      $log['referer'],
      $log['ip'],
      format_date($log['timestamp']));
  }
} */

/* TODO Implement the hook_theme registry. Combine all theme registry entries
   into one hook_theme function in each corresponding module file.
function flvmediaplayer_profiles_theme() {
  return array(
  );
}; */


/* TODO
   An argument for replacements has been added to format_plural(),
   escaping and/or theming the values just as done with t().*/

/* ************************************************************** */
/* PROFILE FUNCTIONS */
/* ************************************************************** */


/**
 * Creates the profile listing page
 * @param int $pid is a profile id
 * @return string
 */
function flvmediaplayer_admin_profiles ($pid = null) {

  // return a profile if it is passed in
  if ($pid) {
    // get config data
    $result = db_fetch_array(db_query('SELECT * FROM {flvmediaplayer_profiles} WHERE pid = %d', $pid));
    drupal_set_title(t('Edit profile: !name', array('!name' => $result['name'])));
    return drupal_get_form('flvmediaplayer_profile_edit_form', $result);
  }

  // set title
  drupal_set_title(t('Profile list'));

  // get the create form
  $output = drupal_get_form('flvmediaplayer_profile_create_form');

  // get existing profiles
  $results = db_query('SELECT pid, name FROM {flvmediaplayer_profiles}');
  while ($result = db_fetch_array($results)) {
    $rows[] = array($result['pid'], l($result['name'], 'admin/settings/flvmediaplayer/profiles/'. $result['pid']));
  }
  if (count($rows)) {
    $header = array(t('Id'), t('Name'));
    $output .= theme('table', $header, $rows);
  }

  return $output;
}


/**
 * form for creating a new profile
 */
function flvmediaplayer_profile_create_form() {
  $form = array();
  $form['create'] = array(
    '#type' => 'fieldset',
    '#title' => t('Create new profile'),
  );
  $form['create']['name'] = array(
    '#type' => 'textfield',
    '#title' => t('Name'),
    '#description' => t('Give your profile a distinct name. Use _ for spaces if you need them.'),
  );
  $form['create']['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Create'),
  );
  return $form;
}


/**
 * validates the name on the create
 */
function flvmediaplayer_profile_create_form_validate($form, &$form_state) {
  if (strstr($form_state['values']['name'], ' ')) {
    form_set_error('name', t('Please do not use spaces in the name.'));
  }
}


/**
 * submits a new profile and returns user to the edit screen
 * @param string $from_id
 *   the form id being passed by drupal
 * @param array $form_values
 *   full drupal form array
 * @return string drupal goto
 */
function flvmediaplayer_profile_create_form_submit($form, &$form_state) {
  // serialize the data from the form
  $data = serialize($form_state['values']);
  $type = 'profile';
  db_query('INSERT INTO {flvmediaplayer_profiles} (type, name, config) VALUES ("%s", "%s", "%s")', $type, $form_state['values']['name'], $data);
  $pid = db_last_insert_id('flvmediaplayer_profiles', 'pid');
  drupal_set_message(t('Created your profile !name', array('!name' => $form_state['values']['name'])));
  $form_state['redirect'] = 'admin/settings/flvmediaplayer/profiles/'. $pid;
}


/**
 * handles the profile config save/delete
 */
function flvmediaplayer_profile_edit_form(&$form_state, $result) {
  // get the data for this profile
  $config = unserialize($result['config']);
  $form = array();
  // create the fieldset
  $form['profiles'][$result['pid']] = array(
    '#type' => 'fieldset',
    '#title' => $result['name'],
  );
  $form['profiles'][$result['pid']]['name'] = array(
    '#type' => 'textfield',
    '#default_value' => $result['name'],
    '#description' => t('The name of your configuration'),
  );

  // grab the settings form
  $form['profiles'][$result['pid']][] = flvmdiaplayer_get_player_form($config);

  // set the pid
  $form['profiles'][$result['pid']]['pid'] = array(
    '#type' => 'hidden',
    '#value' => $result['pid'],
  );

  $form['profiles'][$result['pid']]['submit'] = array(
    '#type' => 'submit',
    '#value' => t('Save'),
  );

  $form['profiles'][$result['pid']]['delete'] = array(
    '#type' => 'submit',
    '#value' => t('Delete'),
  );

  return $form;
}


/**
 * handles the submit of an individual profile form
 */
function flvmediaplayer_profile_edit_form_submit($form, &$form_state) {
/* TODO The 'op' element in the form values is deprecated.
   Each button can have #validate and #submit functions associated with it.
   Thus, there should be one button that submits the form and which invokes
   the normal form_id_validate and form_id_submit handlers. Any additional
   buttons which need to invoke different validate or submit functionality
   should have button-specific functions. */
  switch ($form_state['values']['op']) {
    case t('Delete'):
      db_query('DELETE FROM {flvmediaplayer_profiles} WHERE pid = %d', $form_state['values']['pid']);
      drupal_set_message(t('Deleted your player profile'));
    break;

    case t('Save'):
      $prefix = 'flvmp_';

      foreach ($form_state['values'] as $name => $value) {
        if (strstr($name, $prefix)) {
          $data[str_replace($prefix, '', $name)] = $value;
        }
      }
      // add the profile name to the configuration
      $data['profile_name'] = $form_state['values']['name'];
      $data = serialize($data);
      db_query('UPDATE {flvmediaplayer_profiles} SET name = "%s", config = "%s" WHERE pid = %d', $form_state['values']['name'], $data, $form_state['values']['pid']);
      // clear cached nodes
      cache_clear_all('flvmp_%'. $form_state['values']['name'], 'cache_flvmediaplayer', true);
      drupal_set_message(t('Cleared configuration cache'));
      drupal_set_message(t('Saved your player profile'));
    break;

    default:
    break;
  }
}